#include <vector>
#include <cstdio>
#include <cstdlib> 
#include <cstring>
using namespace std;

#define NMAX 100000
int depth[NMAX];
int queue[NMAX];

vector<int> adj[NMAX];

int main() {
  int N, P, x, y;
  scanf("%d %d", &N, &P);


  for(int i = 0; i < N-1; i++) {
    scanf("%d %d", &x, &y);
    adj[x].push_back(y);
    adj[y].push_back(x);
  }

  //find longest path
  int first = 0, last = 0, indmax = 0;
  memset(depth, -1, N*sizeof(int));
  queue[0] = 0;
  depth[0] = 0;
  while (first<=last) {
    int crt = queue[first];
    if (depth[queue[first]]>depth[queue[indmax]])
        indmax = first;
    for (int i = 0;i<adj[crt].size();++i)
        if (depth[adj[crt][i]] == -1) {
            last ++;
            queue[last] = adj[crt][i];
            depth[queue[last]] = depth[queue[first]]+1;
        }
        first ++;
   }
  
   queue[0] = queue[indmax];

   first = last = indmax = 0;
   memset(depth, -1, N*sizeof(int));
   depth[queue[first]] = 0;
   while (first<=last) {
    int crt = queue[first];
    if (depth[queue[first]]>depth[queue[indmax]])
        indmax = first;
    for (int i = 0;i<adj[crt].size();++i) {
        if (depth[adj[crt][i]] == -1) {
            last++;
            queue[last] = adj[crt][i];
            depth[queue[last]] = depth[queue[first]]+1;
        }
     }
     first++;
   }

   int longest = depth[queue[indmax]];
  // printf("longest : %d\n",longest);
   int basequant = P / (N-1);

   int remaining = P%(N-1);
    //printf("remaining : %d\n",remaining);
    int nl = 0;
    for (int i = 0; i<N; ++i) 
    if (adj[i].size() ==1)
        nl++;
    //printf("%d\n",nl);

   int ans = basequant * longest;
   ans += 2 * (remaining / nl);
   int mod = remaining%nl;
   if (mod)
        ans++;
   
  printf("%d\n",ans);
  return 0;
}
