import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;

public class Vincent3 {
	private static void read() throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		String[] line = br.readLine().split(" ");
		int N = Integer.parseInt(line[0]);
		int P = Integer.parseInt(line[1]);
	        int[] degree = new int[N];
        	for (int e = 0; e < N - 1; e++) {
			line = br.readLine().split(" ");
			degree[Integer.parseInt(line[0])]++;
			degree[Integer.parseInt(line[1])]++;
		}
	        int leaves = 0;
		for (int i = 0; i < N; i++) {
			if (degree[i] == 1) {
				leaves++;
			}
		}
		int K = 2 * (P / leaves) + Math.min(1, P % leaves);
		System.out.println(K);
	}

	public static void main(String[] args) throws IOException {
		read();
	}
}
